/* uDig - User Friendly Desktop Internet GIS client
 * http://udig.refractions.net
 * (C) 2004, Refractions Research Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */
package swt;

import java.awt.Dimension;
import java.awt.GridLayout;

import net.refractions.udig.project.IMap;
import net.refractions.udig.project.internal.Map;
import net.refractions.udig.project.ui.ApplicationGIS;
import net.refractions.udig.project.ui.internal.MapEditor;
import net.refractions.udig.ui.graphics.SWTGraphics;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

/**
 * opens a dialog with the map displayed in the dialog.
 *  
 * @author jones
 * @since 1.1.0
 */
public class OpenDialog implements IWorkbenchWindowActionDelegate {

    private IWorkbenchWindow window;

    public void dispose() {
    }

    public void init( IWorkbenchWindow window ) {
        this.window=window;
    }

    public void run( IAction action ) {
        final IMap map = ApplicationGIS.getActiveMap();
        
        Dialog d=new Dialog(window.getShell()){
            @Override
            protected Control createDialogArea( Composite parent ) {
                final Composite com=new Composite(parent, SWT.NONE);
                com.setLayoutData(new GridData(GridData.FILL_BOTH));
                com.addPaintListener(new PaintListener(){

                    public void paintControl( PaintEvent e ) {
                        Point size = com.getSize();
                        Dimension dim = new Dimension(size.x, size.y);
                        SWTGraphics g=new SWTGraphics(e.gc, e.display, dim );
                        g.clearRect(0,0,size.x, size.y);
                        g.drawImage(map.getRenderManager().getImage(),0,0, size.x, size.y, 0,0, 
                                map.getRenderManager().getMapDisplay().getWidth(), map.getRenderManager().getMapDisplay().getHeight() );
                    }
                    
                });
                
                return com;
            }
        };
        
        d.open();
    }

    public void selectionChanged( IAction action, ISelection selection ) {
    }

}
